stopBackupNow db 0

StartBackuping:
call denter

;allocate memory for the current file
push (260*4) + 2 + 2 ;MAX_PATH + lock byte + zero byte
call GetMemLocation
mov pesi,peax

;allocate memory for the current folder
push (32767*4) + 2 + 2 ;MAX_PATH with preset \\?\ + lock byte + zero byte
call GetMemLocation
mov pedi,peax

;allocate memory for array for 5 pointers
push psize*5
call GetMemLocation
mov pedx,peax


mov pdword [pedx],pedi ;+0x0 => memory for the current folder source
mov pdword [pedx+psize*1],pesi ;+psize*1 => memory for the current file source
mov peax,[CurrentFolderMemLock]
mov pdword [pedx+psize*2],peax ;+psize*2 => memory for the current folder target
mov peax,[CurrentFileMemLock]
mov pdword [pedx+psize*3],peax ;+psize*3 => memory for the current file target
mov peax,Working
mov pdword [pedx+psize*4],peax ;+psize*4 => Working integer, 1=scanning, 2=backuping


push pedx
push copyStringsToBufer
call createthread

push FULL_LOCK
push [Added_files_result]
call LockAntiWriteLockCollection

push changedResults                     ;pointer to incremental dword everytime a result was changed
push stopBackupNow                      ;pointer to stop byte
push pesi                               ;Current working file
push pedi                               ;Current working dir
push [Added_files_result]               ;result boolean collection
push applyAdd                           ;callback function
push 0                                  ;optional extra collection with data like size
push [dAdded_files]                     ;size/aributes/datetime collection
push [Added_files]                      ;dirs and filenames collection
push [Path2]                            ;Target path
push [Path]                             ;Base path
push [Added_files_selected]             ;Selected id's collection
call runThroughList

push FULL_LOCK
push [Added_files_result]
call ExternalUnlockAntiWriteLockCollection

push [Added_files_result]
call MergeAntiWriteLockCollectionWithCollection

inc dword [changedResults]

push FULL_LOCK
push [Modified_Size_files_result]
call LockAntiWriteLockCollection

push changedResults                     ;pointer to incremental dword everytime a result was changed
push stopBackupNow                      ;pointer to stop byte
push pesi                               ;Current working file
push pedi                               ;Current working dir
push [Modified_Size_files_result]       ;result boolean collection
push applySize                          ;callback function
push 0                                  ;optional extra collection with data like size
push [dModified_Size_files]             ;size/aributes/datetime collection
push [Modified_Size_files]              ;dirs and filenames collection
push [Path2]                            ;Target path
push [Path]                             ;Base path
push [Modified_Size_files_selected]     ;Selected id's collection
call runThroughList

push FULL_LOCK
push [Modified_Size_files_result]
call ExternalUnlockAntiWriteLockCollection

push [Modified_Size_files_result]
call MergeAntiWriteLockCollectionWithCollection

inc dword [changedResults]

push FULL_LOCK
push [Modified_TimeDate_files_result]
call LockAntiWriteLockCollection

push changedResults                     ;pointer to incremental dword everytime a result was changed
push stopBackupNow                      ;pointer to stop byte
push pesi                               ;Current working file
push pedi                               ;Current working dir
push [Modified_TimeDate_files_result]   ;result boolean collection
push applyTimeDate                      ;callback function
push [dModified_TimeDate_files_size]    ;optional extra collection with data like size
push [dModified_TimeDate_files]         ;size/aributes/datetime collection
push [Modified_TimeDate_files]          ;dirs and filenames collection
push [Path2]                            ;Target path
push [Path]                             ;Base path
push [Modified_TimeDate_files_selected] ;Selected id's collection
call runThroughList

push FULL_LOCK
push [Modified_TimeDate_files_result]
call ExternalUnlockAntiWriteLockCollection

push [Modified_TimeDate_files_result]
call MergeAntiWriteLockCollectionWithCollection

inc dword [changedResults]

push FULL_LOCK
push [Modified_Attributes_files_result]
call LockAntiWriteLockCollection

push changedResults                     ;pointer to incremental dword everytime a result was changed
push stopBackupNow                      ;pointer to stop byte
push pesi                               ;Current working file
push pedi                               ;Current working dir
push [Modified_Attributes_files_result] ;result boolean collection
push applyAttributes                    ;callback function
push 0                                  ;optional extra collection with data like size
push [dModified_Attributes_files]       ;size/aributes/datetime collection
push [Modified_Attributes_files]        ;dirs and filenames collection
push [Path2]                            ;Target path
push [Path]                             ;Base path
push [Modified_Attributes_files_selected]            ;Selected id's collection
call runThroughList

push FULL_LOCK
push [Modified_Attributes_files_result]
call ExternalUnlockAntiWriteLockCollection

push [Modified_Attributes_files_result]
call MergeAntiWriteLockCollectionWithCollection

inc dword [changedResults]

push FULL_LOCK
push [Deleted_files_result]
call LockAntiWriteLockCollection

push changedResults                     ;pointer to incremental dword everytime a result was changed
push stopBackupNow                      ;pointer to stop byte
push pesi                               ;Current working file
push pedi                               ;Current working dir
push [Deleted_files_result]             ;result boolean collection
push applyRemove                        ;callback function
push 0                                  ;optional extra collection with data like size
push [dDeleted_files]                   ;size/aributes/datetime collection
push [Deleted_files]                    ;dirs and filenames collection
push [Path2]                            ;Target path
push [Path]                             ;Base path
push [Deleted_files_selected]           ;Selected id's collection
call runThroughList

push FULL_LOCK
push [Deleted_files_result]
call ExternalUnlockAntiWriteLockCollection

push [Deleted_files_result]
call MergeAntiWriteLockCollectionWithCollection

inc dword [changedResults]

mov [Working],0

call dleave
ret FunctionReturnFactor

;------------------------------------------------------------------------------

copyStringsToBufer:
StartProc 1 ;set param sess on stack
call denter

if used is32
  mov ecx,dword [pebp+psize*2] ;strcture with pointers
end if

keepCopyingDirAndFile:
  push 100
  call sleep

  mov pesi,pdword [pecx]         ;current folder source
  add pesi,2
  mov pedi,pdword [pecx+psize*2] ;current folder target

  waitForLock pedi

  add pedi,2

  push (32767*4)
  push pesi  ;current folder source
  push pedi  ;current folder target
  call strcpyn

  sub pedi,2
  mov byte[pedi],0 ;remove lock

  mov pesi,pdword [pecx+psize]   ;current file source
  add pesi,2
  mov pedi,pdword [pecx+psize*3] ;current file target

  waitForLock pedi

  add pedi,2

  push (260*4)
  push pesi  ;current folder source
  push pedi  ;current folder target
  call strcpyn

  sub pedi,2
  mov byte[pedi],0 ;remove lock

  mov peax,pdword [pecx+psize*4]
  mov al,byte [peax]
  test al,al
jnz keepCopyingDirAndFile

;free current folder source
mov pesi,pdword [pecx]         ;current folder source
push pesi
call FreeMemLocation

;free current file source
mov pesi,pdword [pecx+psize]   ;current file source
push pesi
call FreeMemLocation

;free structure
push pecx
call FreeMemLocation

call dleave
ret FunctionReturnFactor

;------------------------------------------------------------------------------
;This function will start comparing two directories
;input:
;    1:Selected id's collection
;    2:Base path
;    3:Target path
;    4:dirs and filenames collection
;    5:size/aributes/datetime collection
;    6:optional extra collection with data like size
;    7:callback function
;    8:result boolean collection
;    9:current folder output string, where the first two byte are lock byte
;   10:current file output string, where the first two byte are lock byte
;   11:pointer to stop byte
;   12:pointer to incremental dword everytime a result was changed

;output:
;       None

;callback function signature:
;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size
;    6:qword(x64) or pointer to(x86) old optional extra data like size

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error
;------------------------------------------------------------------------------
runThroughList:
call denter

mov pesi,pdword [pebp+psize*4]   ;R/SI=>Target path
push pesi
call forceCreateLongPath         ;make long path
mov pesi,peax                    ;R/SI=>long Target path

mov pedi,pdword [pebp+psize*3]   ;R/SI=>base path
push pedi
call forceCreateLongPath         ;make long path
mov pedi,peax                    ;R/SI=>long base path

if used is64
  mov r12,pdword [pebp+psize*9] ;R12 => Result boolean collection
  mov r13,pdword [pebp+psize*2] ;R13=>Selected id's collection
  mov r14,pdword [pebp+psize*5] ;R14=>dirs and filenames collection
  mov r15,pdword [pebp+psize*6] ;R15=>size/aributes/datetime collection
end if
push pdword [pebp+psize*2] ;Selected id's collection
call CountItems
mov pecx,peax
test peax,peax
jz endRunThroughList

loopThroughSelectedFiles:
  ;is item selected?
  push pecx ;itemId
  if used is64
    push r13
  else
    push pdword [pebp+psize*2] ;Selected id's collection
  end if
  call GetDwordItem
  test eax,eax
  jz nextLoopThroughSelectedFiles  ;jump if not selected

  ;is item already executed
  push pecx ;itemId
  if used is64
    push r12
  else
    push pdword [pebp+psize*9] ;Result boolean collection
  end if
  call GetDwordItem
  cmp eax,1
  jz nextLoopThroughSelectedFiles ;jump if already executed and successfull!


     mov peax,pecx   ;itemId
     shl peax,1 ;*2  ;Get filename
     dec eax         ;go to path

     ;get path of item
     push peax
     if used i64
       push r14                    ;dirs and filenames collection
     else
       push pdword [pebp+psize*5]  ;dirs and filenames collection
     end if
     call GetItem
     mov pedx,peax ;R/EDX => path to item '

     mov peax,pdword [pebp+psize*10] ;current folder output string, where the first two byte are lock byte
     test peax,peax
     jz dontCopyPathToBuffer
     tryLockDontWait peax,dontCopyPathToBuffer

       add peax,2 ;skip lock byte

       push pedx ;current folder
       push peax ;current folder output string
       call strcpyW

       mov peax,pdword [pebp+psize*10] ;current folder output string, where the first two byte are lock byte
       mov byte [peax],0 ;clear lock

     dontCopyPathToBuffer:
     mov peax,pecx   ;itemId
     shl peax,1 ;*2  ;Get filename

     ;get filename of item
     push peax
     if used i64
       push r14                    ;dirs and filenames collection
     else
       push pdword [pebp+psize*5]  ;dirs and filenames collection
     end if
     call GetItem
     mov pebx,peax ;R/EBX => filenme of item

     mov peax,pdword [pebp+psize*11] ;current file output string, where the first two byte are lock byte
     test peax,peax
     jz dontCopyFileToBuffer
     tryLockDontWait peax,dontCopyFileToBuffer

       add peax,2 ;skip lock byte

       push pebx ;current file
       push peax ;current folder output string
       call strcpyW

       mov peax,pdword [pebp+psize*11] ;current file output string, where the first two byte are lock byte
       mov byte [peax],0 ;clear lock

     dontCopyFileToBuffer:

     ;create base url
     push 0    ;last item
     push pebx ;filename
     push 0x2  ;UTF-16
     push pedx ;path to item
     push 0x2  ;UTF-16
     push pedi ;base url
     push 0x2  ;UTF-16
     call CreateOneString

     ;create target url
     push 0    ;last item
     push pebx ;filename
     push 0x2  ;UTF-16
     push pedx ;path to item
     push 0x2  ;UTF-16
     push pesi ;base url
     push 0x2  ;UTF-16

     mov pedx,peax ;R/EDX =>  base url

     call CreateOneString
     mov pebx,peax ;R/EBX =>  target url

     push 0 ;no optional extra data
     push 0 ;no optional extra data

     cmp pdword [pebp+psize*7],0 ;is optional extra collection with data like size present?
     je noOptionalCollection

       add pesp,psize*2 ;pop the 2xzero from stack

       ;get old value of the optional extra collection with data like size
       mov peax,pecx   ;itemId
       if used is32
          shl eax,2 ;*4
          sub eax,3 ;get low part (old)
       else
         shl rax,1 ;*2
         dec rax ;get old
       end if

       push peax                   ;itemId
       push pdword [pebp+psize*7]  ;optional extra collection with data like size
       if used is64
         call GetDwordItem
       else
         call GetDwordItemPointer
       end if

       push peax  ;pushg optional extra data like size (old)

       ;get new value of the optional extra collection with data like size
       mov peax,pecx   ;itemId
       if used is32
         shl eax,2 ;*4
         dec eax ;get low part of (new)
       else
         shl rax,1 ;*2
       end if

       push peax                   ;itemId
       push pdword [pebp+psize*7]  ;optional extra collection with data like size
       if used is64
         call GetDwordItem
       else
         call GetDwordItemPointer
       end if

       push peax  ;pushg optional extra data like size (new)

    noOptionalCollection:
    ;get old value of the size/aributes/datetime collection
    mov peax,pecx   ;itemId
    if used is32
       shl eax,2 ;*4
       sub eax,3 ;get low part (old)
    else
      shl rax,1 ;*2
      dec rax ;get old
     end if

    push peax                   ;itemId
    if used is64
      push r15  ;size/aributes/datetime collection
      call GetDwordItem
    else
      push pdword [pebp+psize*6]  ;size/aributes/datetime collection
      call GetDwordItemPointer
    end if

    push peax  ;push size/aributes/datetime collection  (old)

    ;get new value of the size/aributes/datetime collection
    mov peax,pecx   ;itemId
    if used is32
      shl eax,2 ;*4
      dec eax ;get low part of (new)
    else
      shl rax,1 ;*2
    end if

    push peax                   ;itemId
    if used is64
      push r15  ;;size/aributes/datetime collection
      call GetDwordItem
    else
      push pdword [pebp+psize*6]  ;size/aributes/datetime collection
      call GetDwordItemPointer
    end if

    push peax  ;push size/aributes/datetime collection  (new)
    push pebx  ;target url
    push pedx  ;base url
    call pdword [pebp+psize*8] ;callback function

    push peax ;push for ModifyDword

    if used is64
      push r12  ;Result boolean collection
    else
      push pdword [pebp+psize*9] ;Result boolean collection
    end if
    call CountItems
    cmp peax,pecx
    jae dontNeedToAddResults

    ;add items until you added the items that is being set
    __addUnavailableItems:
      push 0 ;set as unselected
      if used is64
        push r12  ;Result boolean collection
      else
        push pdword [pebp+psize*9] ;Result boolean collection
      end if
      call AddDword
      cmp peax,pecx
    jb __addUnavailableItems ;jump if the item you want to set is not yet aded

    dontNeedToAddResults:
    ;set selection
    ;push 1  (value is already pushed)
    push pecx ;itemId
    if used is64
      push r12  ;Result boolean collection
    else
      push pdword [pebp+psize*9] ;Result boolean collection
    end if
    call ModifyDword

    ;increment dword that holds the amount of changed results
    mov peax,pdword [pebp+psize*13]
    test peax,peax
    jz noIncrementalResultPresent

      inc pdword [peax]

    noIncrementalResultPresent:

    ;Free base location
    push pedx
    call FreeMemLocation

    ;Free target location
    push pebx
    call FreeMemLocation

nextLoopThroughSelectedFiles:
;is the stop byte signaled?
mov peax,pdword [pebp+psize*12]
test peax,peax
jz noStopBytePresent

  cmp byte[peax],1
  je endRunThroughList

noStopBytePresent:
dec pecx
jnz loopThroughSelectedFiles

endRunThroughList:

cmp pedi,pdword [pebp+psize*3] ;is base path an other pointer
je basePathSouldNotBeReleased

  ;then free pointer
  push pedi
  call FreeMemLocation

basePathSouldNotBeReleased:

cmp pesi,pdword [pebp+psize*4] ;is target path an other pointer
je targetPathSouldNotBeReleased

  ;then free pointer
  push pesi
  call FreeMemLocation

targetPathSouldNotBeReleased:

call dleave
ret psize*11




;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size
;    6:qword(x64) or pointer to(x86) old optional extra data like size (not used here, is always zero

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error

;         2  => base file size does not match
;         3  => target file size does not match
;         4  => base file attributes does not match
;         5  => target file attributes does not match
;         6  => base file datetime does not match
;         7  => target file datetime does not match
;         8  => base file not found
;         9  => target file not found
;         10 => could not open target file for write
;         11 => could not read from base file
;         12 => could not write to target file
;         13 => could not set target file datetime
;         14 => the size of the target file does not match the size of the base file after coping
;         15 => the attributes of the target file do not match the attributes of the base file after coping
;         16 => could not remove file

;------------------------------------------------------------------------------
applyTimeDate:
call denter

mov pedi,pdword [pebp+psize*2] ;R/EDI => Base url
mov pesi,pdword [pebp+psize*4] ;R/ESI => new datetime
mov pedx,pdword [pebp+psize*6] ;R/EDX => new file size
xor ecx,ecx                    ;R/ECX => target/base error code

doBaseTargetCheck:
;------------------
;check if the size is the same as when the folders where scanned
;------------------
push 0                     ;READ
push pedi                  ;base file
call openFileHandle
mov ebx,8                  ;ret value if error
add ebx,ecx                ;add target/base error code
add peax,1                 ;if openFileHandle failed, -1 is returned, +1 is zero
cmovc eax,ebx              ;if openFileHandle failed, set eax = error code
jc endApplyTimeDate        ;jump if openFileHandle if failed
sub peax,1                 ;restore file handel
mov pebx,peax              ;R/EBX => Base file handle

;------------
;check last modified date time
;------------
if used is32
  ;FILETIME
  push 0
  push 0

push pesp   ;FILETIME pointer
end if
push pebx   ;File handle
call getRawLastWriteTime

if used is64
  cmp peax,pesi               ;new datetime
else
  push pesp                   ;FILETIME struct
  push pesi                   ;new datetime
  call cmpQword
end if
mov peax,6 ;base file datetime does not match

jne endBaseTargetFileCheck

;------------
;check size
;------------
;Already pushed on stack as FILETIME
;-if used is32
;-  ;Long long
;-  push 0
;-  push 0
;end if

if used is32
  push pesp   ;Long long pointer
end if
push pebx   ;File handle
call getfilesizeLongLong

if used is64
  cmp peax,pedx               ;new file size
else
  push pesp                   ;Long long struct
  push pedx                   ;new file size
  call cmpQword
end if
mov peax,2 ;base file datetime does not match
jne endBaseTargetFileCheck

;close base file
push pebx
call closefile

if used is32
  add pesp,psize*2 ;remove FILETIMe/ LONG long from stack
end if

cmp pedi,pdword [pebp+psize*2] ;R/EDI =(?)> Base url
jne TargetIsCheckedAsWell

mov pedi,pdword [pebp+psize*3] ;R/EDI => Target url
mov pesi,pdword [pebp+psize*5] ;R/ESI => old datetime
;--mov pedx,pdword [pebp+psize*6] ;R/EDX => new file size   is the same for target and base
inc ecx                        ;R/ECX => Error base code (1)
jmp doBaseTargetCheck

TargetIsCheckedAsWell:
;Copy file
push backupedSize          ;pointer to total backuped size
push pdword [pebp+psize*6] ;size
push pdword [pebp+psize*3] ;Target url
push pdword [pebp+psize*2] ;Base url
call copyFile

endApplyTimeDate:
call dleave
ret psize*6

endBaseTargetFileCheck:
if used is32
  add pesp,psize*2 ;remove Long Long or FILETIME from stack
end if

add eax,ecx ;add base error code to error code
push peax ;save return value

;close base/target file
push pebx
call closefile

pop peax ;restore return value
jmp endApplyTimeDate

;------------------------------------------------

;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size (not used here, is always zero)
;    6:qword(x64) or pointer to(x86) old optional extra data like size (not used here, is always zero)

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error

;         2  => base file size does not match
;         3  => target file size does not match
;         4  => base file attributes does not match
;         5  => target file attributes does not match
;         6  => base file datetime does not match
;         7  => target file datetime does not match
;         8  => base file not found
;         9  => target file not found
;         10 => could not open target file for write
;         11 => could not read from base file
;         12 => could not write to target file
;         13 => could not set target file datetime
;         14 => the size of the target file does not match the size of the base file after coping
;         15 => the attributes of the target file do not match the attributes of the base file after coping
;         16 => could not remove file

;------------------------------------------------------------------------------
applySize:
call denter

mov pedi,pdword [pebp+psize*2] ;R/EDI => Base url
mov pesi,pdword [pebp+psize*4] ;R/ESI => new file size
xor ecx,ecx                    ;R/ECX => target/base error code

doBaseTargetCheckSize:
;------------------
;check if the size is the same as when the folders where scanned
;------------------
push 0                     ;READ
push pedi                  ;base file
call openFileHandle
mov ebx,8                  ;ret value if error
add ebx,ecx                ;add target/base error code
add peax,1                 ;if openFileHandle failed, -1 is returned, +1 is zero
cmovc eax,ebx              ;if openFileHandle failed, set eax = error code
jc endApplySize            ;jump if openFileHandle if failed
sub peax,1                 ;restore file handel
mov pebx,peax              ;R/EBX => Base file handle

;------------
;check size
;-----------
if used is32
  ;Long Long
  push 0
  push 0

push pesp   ;FILETIME pointer
end if
push pebx   ;File handle
call getfilesizeLongLong

if used is64
  cmp peax,pesi               ;new file size
else
  push pesp                   ;Long long struct
  push pesi                   ;new file size
  call cmpQword
end if
mov peax,2 ;base file datetime does not match
jne endBaseTargetFileCheckSize

;close base file
push pebx
call closefile

if used is32
  add pesp,psize*2 ;remove LONG long from stack
end if

cmp pedi,pdword [pebp+psize*2] ;R/EDI =(?)> Base url
jne TargetIsCheckedAsWellSize

mov pedi,pdword [pebp+psize*3] ;R/EDI => Target url
mov pesi,pdword [pebp+psize*5] ;R/ESI => old file size
inc ecx                        ;R/ECX => Error base code (1)
jmp doBaseTargetCheckSize

TargetIsCheckedAsWellSize:
;copy file
push backupedSize          ;pointer to total backuped size
push pdword [pebp+psize*4] ;base file size
push pdword [pebp+psize*3] ;Target url
push pdword [pebp+psize*2] ;Base url
call copyFile

endApplySize:
call dleave
ret psize*6

endBaseTargetFileCheckSize:
if used is32
  add pesp,psize*2 ;remove Long Long or FILETIME from stack
end if

add eax,ecx ;add base error code to error code
push peax ;save return value

;close base/target file
push pebx
call closefile

pop peax ;restore return value
jmp endApplySize

;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size (not used here, is always zero)
;    6:qword(x64) or pointer to(x86) old optional extra data like size (not used here, is always zero)

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error

;         2  => base file size does not match
;         3  => target file size does not match
;         4  => base file attributes does not match
;         5  => target file attributes does not match
;         6  => base file datetime does not match
;         7  => target file datetime does not match
;         8  => base file not found
;         9  => target file not found
;         10 => could not open target file for write
;         11 => could not read from base file
;         12 => could not write to target file
;         13 => could not set target file datetime
;         14 => the size of the target file does not match the size of the base file after coping
;         15 => the attributes of the target file do not match the attributes of the base file after coping
;         16 => could not remove file

;------------------------------------------------------------------------------
applyAdd:
call denter

mov pedi,pdword [pebp+psize*2] ;R/EDI => Base url
mov pesi,pdword [pebp+psize*4] ;R/ESI => new file size
xor ecx,ecx                    ;R/ECX => target/base error code

;------------------
;check if the size is the same as when the folders where scanned
;------------------
push 0                     ;READ
push pedi                  ;base file
call openFileHandle
mov ebx,8        ;ret value if error
add ebx,ecx      ;add target/base error code
add peax,1       ;if openFileHandle failed, -1 is returned, +1 is zero
cmovc eax,ebx    ;if openFileHandle failed, set eax = error code
jc endApplyAdd   ;jump if openFileHandle if failed
sub peax,1       ;restore file handel
mov pebx,peax    ;R/EBX => Base file handle

;------------
;check size
;-----------
if used is32
  ;Long Long
  push 0
  push 0

push pesp   ;Long Long pointer
end if
push pebx   ;File handle
call getfilesizeLongLong

if used is64
  cmp peax,pesi               ;new file size
else
  push pesp                   ;Long long struct
  push pesi                   ;new file size
  call cmpQword
end if
mov peax,2 ;base file datetime does not match
jne endBaseTargetFileCheckAdd

;close base file
push pebx
call closefile

if used is32
  add pesp,psize*2 ;remove LONG long from stack
end if

push 1                     ;0x1 => file is in the URL
push pdword [pebp+psize*3] ;Target url
call createAllDirectoriesEx

push backupedSize          ;pointer to total backuped size
push pdword [pebp+psize*4] ;base file size
push pdword [pebp+psize*3] ;Target url
push pdword [pebp+psize*2] ;Base url
call copyFile

endApplyAdd:
call dleave
ret psize*6

endBaseTargetFileCheckAdd:
if used is32
  add pesp,psize*2 ;remove Long Long or FILETIME from stack
end if

add eax,ecx ;add base error code to error code
push peax ;save return value

;close base/target file
push pebx
call closefile

pop peax ;restore return value
jmp endApplyAdd

;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size (not used here, is always zero)
;    6:qword(x64) or pointer to(x86) old optional extra data like size (not used here, is always zero)

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error

;         2  => base file size does not match
;         3  => target file size does not match
;         4  => base file attributes does not match
;         5  => target file attributes does not match
;         6  => base file datetime does not match
;         7  => target file datetime does not match
;         8  => base file not found
;         9  => target file not found
;         10 => could not open target file for write
;         11 => could not read from base file
;         12 => could not write to target file
;         13 => could not set target file datetime
;         14 => the size of the target file does not match the size of the base file after coping
;         15 => the attributes of the target file do not match the attributes of the base file after coping
;         16 => could not remove file

;------------------------------------------------------------------------------
applyRemove:
call denter

mov pedi,pdword [pebp+psize*3] ;R/EDI => Target url
mov pesi,pdword [pebp+psize*5] ;R/ESI => old file size
mov ecx,1                      ;R/ECX => target/base error code

;------------------
;check if the size is the same as when the folders where scanned
;------------------
push 0                     ;READ
push pedi                  ;base file
call openFileHandle
mov ebx,8         ;ret value if error
add ebx,ecx       ;add target/base error code
add peax,1        ;if openFileHandle failed, -1 is returned, +1 is zero
cmovc eax,ebx     ;if openFileHandle failed, set eax = error code
jc endApplyRemove ;jump if openFileHandle if failed
sub peax,1        ;restore file handel
mov pebx,peax     ;R/EBX => Base file handle

;------------
;check size
;-----------
if used is32
  ;Long Long
  push 0
  push 0

push pesp   ;Long Long pointer
end if
push pebx   ;File handle
call getfilesizeLongLong

if used is64
  cmp peax,pesi               ;new file size
else
  push pesp                   ;Long long struct
  push pesi                   ;new file size
  call cmpQword
end if
mov peax,2 ;base file datetime does not match
jne endBaseTargetFileCheckRemove

;close base file
push pebx
call closefile

if used is32
  add pesp,psize*2 ;remove LONG long from stack
end if

;remove file
push pdword [pebp+psize*3]
call removeFile

  if used is64
    lock add [removedFiles],rax
  else
    mov ecx,eax
    push removedFiles
    call AddToQword
  end if

test eax,eax
jnz endApplyRemove

endApplyRemove:
call dleave
ret psize*6

endBaseTargetFileCheckRemove:
if used is32
  add pesp,psize*2 ;remove Long Long or FILETIME from stack
end if

add eax,ecx ;add base error code to error code
push peax ;save return value

;close base/target file
push pebx
call closefile

pop peax ;restore return value
jmp endApplyRemove

;------------------------------------------------------------------------------
;This function is a callback function from runThroughList
;input:
;    1:Base url
;    2:Target url
;    3:qword(x64) or pointer to(x86) new size/aributes/datetime
;    4:qword(x64) or pointer to(x86) old size/aributes/datetime 
;    5:qword(x64) or pointer to(x86) new optional extra data like size (not used here, is always zero)
;    6:qword(x64) or pointer to(x86) old optional extra data like size (not used here, is always zero)

;output:
;       Result:
;         0  => not started
;         1  => Success
;         1+ => error

;         2  => base file size does not match
;         3  => target file size does not match
;         4  => base file attributes does not match
;         5  => target file attributes does not match
;         6  => base file datetime does not match
;         7  => target file datetime does not match
;         8  => base file not found
;         9  => target file not found
;         10 => could not open target file for write
;         11 => could not read from base file
;         12 => could not write to target file
;         13 => could not set target file datetime
;         14 => the size of the target file does not match the size of the base file after coping
;         15 => the attributes of the target file do not match the attributes of the base file after coping
;         16 => the attributes of the target file do not match the attributes of the base file even if they where set


;------------------------------------------------------------------------------
applyAttributes:
call denter

mov pedi,pdword [pebp+psize*2] ;R/EDI => Base url
mov pesi,pdword [pebp+psize*4] ;R/ESI => new file aributes
if used is32
  mov esi,dword [pesi]
end if
xor ecx,ecx                    ;R/ECX => target/base error code

ckeckAttributes:
;------------------
;check if the size is the same as when the folders where scanned
;------------------
push 0                     ;READ
push pedi                  ;base file
call openFileHandle
mov ebx,8                  ;ret value if error
add ebx,ecx                ;add target/base error code
add peax,1                 ;if openFileHandle failed, -1 is returned, +1 is zero
cmovc eax,ebx              ;if openFileHandle failed, set eax = error code
jc endApplyAttributes      ;jump if openFileHandle if failed
sub peax,1                 ;restore file handel
mov pebx,peax              ;R/EBX => Base file handle

push pebx
call closefile

;------------
;check attributes
;-----------

push pedi                  ;base file
call getFileAttributes
cmp eax,esi
mov eax,4                  ;base file attributes does not match
jne endBaseTargetFileCheckAttributes

test ecx,ecx
jnz targetFileIsAlreadyChecked

mov pedi,pdword [pebp+psize*3] ;R/EDI => Target url
mov pesi,pdword [pebp+psize*5] ;R/ESI => old file aributes
if used is32
  mov esi,dword [pesi]
end if
inc ecx                        ;R/ECX => Error base code (1)
jmp ckeckAttributes

targetFileIsAlreadyChecked:
mov pesi,pdword [pebp+psize*4] ;R/ESI => new file aributes
if used is32
  mov esi,dword [pesi]
end if

;Set Attributes of target file
push pesi                     ; new file aributes
push pdword [pebp+psize*3]    ; Target url
call setFileAttributes

;turn of flags that cannot be set by setFileAttributes
mov eax,ATTRIBUTES_NOT_SET_BY_SetFileAttributes
and peax,pdword [pebp+psize*4]
xor pdword [pebp+psize*4],peax

mov edx,ATTRIBUTES_NOT_SET_BY_SetFileAttributes
and edx,esi
xor esi,edx

;check if attributes are changed
push pdword [pebp+psize*3]    ; Target url
call getFileAttributes

;turn of flags that cannot be set by setFileAttributes
mov edx,ATTRIBUTES_NOT_SET_BY_SetFileAttributes
and edx,eax
xor eax,edx

cmp eax,esi                   ;validate attributes
mov eax,15                    ;error code 16=>cannot change attributes
jne endApplyAttributes

  if used is64
    lock inc [changedAttributesFiles]
  else
    xor ecx,ecx
    inc ecx
    push changedAttributesFiles
    call AddToQword
  end if

xor eax,eax
inc eax ;good result

endApplyAttributes:
call dleave
ret psize*6

endBaseTargetFileCheckAttributes:
add eax,ecx ;add base error code to error code
jmp endApplyAttributes